#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>

// Some DEFINES. 

#define BUFLEN 1024
#define STRLEN 512
#define STRMINLEN 16

void error(char *s)
{
    perror(s);
    exit(1);
}

// returns the time in msec in a string
char *utime(char *time)
{
  struct timeval t;
	
  gettimeofday(&t, NULL);

  if((t.tv_usec/1000)>100)
  	sprintf(time,"%ld%ld", t.tv_sec , t.tv_usec/1000);
  else if((t.tv_usec/1000)>10) 
	sprintf(time,"%ld0%ld", t.tv_sec , t.tv_usec/1000);
  else
  	sprintf(time,"%ld00%ld", t.tv_sec , t.tv_usec/1000);
  return time;
}

int main(int argc,char **argv)
{
        struct sockaddr_in si_me, si_other;
        int s, i, slen=sizeof(si_other), N,j,k,rndstrlen;
        char buf[BUFLEN], rndstr[STRLEN];
	char timebuf[16];

	if (argc !=2){
		printf("usage: %s <port>\n",argv[0]);
		exit(1);
	}
        
	srand ( time(NULL) );

    /* We request a UDP socket from the OS, allocate the memory
       and initialise it 
    */
        if ((s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP))==-1)
          error("socket");
    
        memset((char *) &si_me, 0, sizeof(si_me));
        si_me.sin_family = AF_INET;
        si_me.sin_port = htons(atoi(argv[1]));  // we request a specific port (the 1st argument)
        si_me.sin_addr.s_addr = htonl(INADDR_ANY);
        if (bind(s, (struct sockaddr *) &si_me, sizeof(si_me))==-1)
            error("bind");

	printf("HY335 Project Server\n");
	printf("port: %d\n",atoi(argv[1]));
    
    //Constantly check for incoming packets
        for (;;) {
        	if (recvfrom(s, buf, BUFLEN, 0, (struct sockaddr *) &si_other, &slen)==-1)
            		error("recvfrom()");
		
			j=0;
			while(buf[j]!='#' && j<strlen(buf))
		  		j++;
		  	// Find the delimiting character, and change it to string termination
		  	// This way the buffer now contains a string with the number of requests :D
			if(buf[j]=='#')
		  		buf[j]='\0';
			else
		  		continue;
	
			N=atoi(buf);
			if(N<1||N>100000) //ignore insane requests
		  		continue;
			
			//Time to respond
			for(j=0;j<N;j++){
				memset(buf,0,BUFLEN);
				rndstrlen=rand()%STRLEN-STRMINLEN;           // create the random string
					for(k=0;k<rndstrlen+STRMINLEN;k++)
						rndstr[k]=rand()%24 + 'a';
				rndstr[rndstrlen]='\0';
	
				sprintf(buf,"%d#%s#%s",j,utime(timebuf),rndstr);  // print to buffer
	
	          	//send buffer through the socket, TO &si_other
	          	if (sendto(s, buf, strlen(buf), 0, (struct sockaddr *) &si_other, slen)==-1) 
	           	  error("sendto()");
	
			}
		}
        close(s);
        return 0;
}


 
