
import java.io.*;
import java.net.*;

public class TCPClient {
    public static void main(String[] args) throws IOException {

        Socket socket = null;
        PrintWriter out = null;
        BufferedReader in = null;
        
        int port;
        String host;
        
        if (args.length==2){
            host = args[0];
            port = Integer.parseInt(args[1]);
        }  
        else {
            host = "localhost";
            port = 12321;
        }
            
        System.out.println("Attempting connection to "+ host + " on port " + port);
        try {
            socket = new Socket(host, port);
            System.out.println("Connected to "+ host + " on port " + port);
            out = new PrintWriter(socket.getOutputStream(), true);
            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: "+ host);
            System.exit(1);
        } catch (IOException e) {
            System.err.println("Couldn't get I/O for the connection to: " + host);
            System.exit(1);
        }

        BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
        String fromServer;
        String fromUser;

        System.out.print("Sending to server: ");
        fromUser = stdIn.readLine();
	if (fromUser != null) {
            //System.out.println("Client: " + fromUser);
            out.println(fromUser);
	}
        
        System.out.print("Receiving from server: ");
        fromServer = in.readLine();
        System.out.println(fromServer);

        out.close();
        in.close();
        stdIn.close();
        socket.close();
    }
}
