

import java.net.*;
import java.io.*;

public class TCPServer {
    public static void main(String[] args) throws IOException {
        int port;
        if (args.length==1)
            port = Integer.parseInt(args[0]);
        else 
            port = 12321;
        
        ServerSocket serverSocket = null;
        try {
            serverSocket = new ServerSocket(port);
            
        } catch (IOException e) {
            System.err.println("Could not listen on port: "+ port);
            System.exit(1);
        }

        Socket clientSocket = null;
        try {
            System.out.println("Listening on port: "+port);
            clientSocket = serverSocket.accept();
            System.out.println("Accepted Connection from "+ clientSocket.getInetAddress().getHostAddress());
        } catch (IOException e) {
            System.err.println("Accept failed.");
            System.exit(1);
        }

        PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
        BufferedReader in = new BufferedReader(
				new InputStreamReader(
				clientSocket.getInputStream()));
        String inputLine, outputLine;

        
        inputLine = in.readLine();
        System.out.println("Received from client: " + inputLine);
        
        outputLine = inputLine.toLowerCase();
        System.out.println("Sending to client: " + outputLine);
        
        out.println(outputLine);

        out.close();
        in.close();
        clientSocket.close();
        serverSocket.close();
    }
}
