
import java.io.*;
import java.net.*;

public class UDPClient {
    public static void main(String[] args) throws IOException {

        BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
        
        int port;
        String host;
        
        if (args.length==2){
            host = args[0];
            port = Integer.parseInt(args[1]);
        }  
        else {
            host = "localhost";
            port = 12321;
        }
        
        System.out.println("UDP CLIENT DEMO");

        // GET USER INPUT
        System.out.print("Type something: ");
        String userIn = stdIn.readLine();
        
        
        // CREATE AND SEND A UDP PACKET
        byte[] buf = new byte[256];
        buf = userIn.getBytes();
        DatagramSocket socket = new DatagramSocket();
        InetAddress address = InetAddress.getByName(host);
        DatagramPacket packet = new DatagramPacket(buf, buf.length, address, port);
        socket.send(packet);
        System.out.println("Sent to " + host + ":" + port + " the message: " + userIn);
 
        // GET RESPONSE
        packet = new DatagramPacket(buf, buf.length);
        socket.receive(packet);
        String received = new String(packet.getData(), 0, packet.getLength());
        System.out.println("Received from " + packet.getAddress().getHostAddress() + ":" + packet.getPort() + " the message: " + received);
    
        // EXIT
        socket.close();
        System.out.println("Exiting..");
    }
 
}
