

import java.net.*;
import java.io.*;

public class UDPServer {
    public static void main(String[] args) throws IOException {
        int port;
        if (args.length==1)
            port = Integer.parseInt(args[0]);
        else 
            port = 12321;
        
        System.out.println("UDP SERVER DEMO");
        
        // WAITING FOR UDP PACKETS
        DatagramSocket socket = null;
        socket = new DatagramSocket(port);
        System.out.println("Waiting for UDP packets on port: "+port);

        byte[] buf = new byte[256];

        // RECEIVE UDP PACKET
        DatagramPacket packet = new DatagramPacket(buf, buf.length);
        socket.receive(packet);

        String received = new String(packet.getData(), 0, packet.getLength());
        InetAddress raddress = packet.getAddress();
        int rport = packet.getPort();
        System.out.println("Received from " + raddress.getHostAddress() + ":" + rport + " the message: " + received);
        
    
        // PROCESS REMOTE REQUEST
        String output = received.toLowerCase();
        
        // SEND RESPONSE
        buf = output.getBytes();
        packet = new DatagramPacket(buf, buf.length, raddress, rport);
        socket.send(packet);
        System.out.println("Sent to " + raddress.getHostAddress() + ":" + rport + " the message: " + output);
       
        // EXIT
        socket.close();
        System.out.println("Exiting..");
    }
    
}    


        
        
     /*   ServerSocket serverSocket = null;
        try {
            serverSocket = new ServerSocket(port);
            System.out.println("Listening on port: "+port);
        } catch (IOException e) {
            System.err.println("Could not listen on port: 4444.");
            System.exit(1);
        }

        Socket clientSocket = null;
        try {
            clientSocket = serverSocket.accept();
            System.out.println("Accepted Connection from "+ clientSocket.getInetAddress().getHostAddress());
        } catch (IOException e) {
            System.err.println("Accept failed.");
            System.exit(1);
        }

        PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
        BufferedReader in = new BufferedReader(
				new InputStreamReader(
				clientSocket.getInputStream()));
        String inputLine, outputLine;

        
        inputLine = in.readLine();
        System.out.println("Received from client: " + inputLine);
        
        outputLine = inputLine.toLowerCase();
        System.out.println("Sending to client: " + outputLine);
        
        out.println(outputLine);

        out.close();
        in.close();
        clientSocket.close();
        serverSocket.close();
    }
}*/
